Package ghidra.trace.model.breakpoint

# Interface TraceBreakpointCommon

All Superinterfaces:
  `TraceObjectInterface`, `TraceUniqueObject`

All Known Subinterfaces:
  `TraceBreakpointLocation`, `TraceBreakpointSpec`

All Known Implementing Classes:
  `DBTraceBreakpointLocation`, `DBTraceBreakpointSpec`

public interface TraceBreakpointCommon extends TraceUniqueObject, TraceObjectInterface

- ## Field Summary

  ### Fields inherited from interface ghidra.trace.model.target.iface.TraceObjectInterface

  `KEY_COMMENT, KEY_DISPLAY, KEY_KIND, KEY_MODIFIED, KEY_ORDER, KEY_SHORT_DISPLAY, KEY_TYPE, KEY_VALUE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `delete()`
  Delete this breakpoint from the trace
  `String`
  `getComment(long snap)`
  Get the comment on this breakpoint
  `String`
  `getName(long snap)`
  Get the "short name" of this breakpoint
  `String`
  `getPath()`
  Get the "full name" of this breakpoint
  `Trace`
  `getTrace()`
  Get the trace containing this breakpoint
  `boolean`
  `isAlive(Lifespan span)`
  Check if the breakpoint is present for any of the given span
  `boolean`
  `isEnabled(long snap)`
  Check whether this breakpoint is enabled or disabled at the given snap
  `boolean`
  `isValid(long snap)`
  Check if the breakpoint is present at the given snapshot
  `void`
  `remove(long snap)`
  Remove this breakpoint from the given snap on
  `void`
  `setComment(long snap, String comment)`
  Set a comment on this breakpoint
  `void`
  `setComment(Lifespan lifespan, String comment)`
  Set a comment on this breakpoint
  `void`
  `setEnabled(long snap, boolean enabled)`
  Set whether this breakpoint was enabled or disabled
  `void`
  `setEnabled(Lifespan lifespan, boolean enabled)`
  Set whether this breakpoint was enabled or disabled
  `void`
  `setName(long snap, String name)`
  Set the "short name" of this breakpoint
  `void`
  `setName(Lifespan lifespan, String name)`
  Set the "short name" of this breakpoint

  ### Methods inherited from interface ghidra.trace.model.target.iface.TraceObjectInterface

  `getObject`

  ### Methods inherited from interface ghidra.trace.model.TraceUniqueObject

  `getObjectKey, isDeleted`

- ## Method Details

  - ### getTrace

    Trace getTrace()
    Get the trace containing this breakpoint
    Returns:
      the trace

  - ### getPath

    String getPath()
    Get the "full name" of this breakpoint

    This is a name unique to this breakpoint, which may not be suitable for display on the screen.

    Returns:
      the path

  - ### setName

    void setName(Lifespan lifespan, String name)
    Set the "short name" of this breakpoint

    This should be a name suitable for display on the screen

    Parameters:
      `lifespan` - the span of time
      `name` - the new name

  - ### setName

    void setName(long snap, String name)
    Set the "short name" of this breakpoint

    This should be a name suitable for display on the screen

    Parameters:
      `snap` - the first effective snap
      `name` - the new name

  - ### getName

    String getName(long snap)
    Get the "short name" of this breakpoint

    This defaults to the "full name," but can be modified via `setName(long, String)`

    Parameters:
      `snap` - the snap
    Returns:
      the name

  - ### setEnabled

    void setEnabled(Lifespan lifespan, boolean enabled)
    Set whether this breakpoint was enabled or disabled
    Parameters:
      `lifespan` - the span of time
      `enabled` - true if enabled, false if disabled

  - ### setEnabled

    void setEnabled(long snap, boolean enabled)
    Set whether this breakpoint was enabled or disabled
    Parameters:
      `snap` - the first effective snap
      `enabled` - true if enabled, false if disabled

  - ### isEnabled

    boolean isEnabled(long snap)
    Check whether this breakpoint is enabled or disabled at the given snap
    Parameters:
      `snap` - the snap
    Returns:
      true if enabled, false if disabled

  - ### setComment

    void setComment(Lifespan lifespan, String comment)
    Set a comment on this breakpoint
    Parameters:
      `lifespan` - the span of time
      `comment` - the comment, possibly `null`

  - ### setComment

    void setComment(long snap, String comment)
    Set a comment on this breakpoint
    Parameters:
      `snap` - the snap
      `comment` - the comment, possibly `null`

  - ### getComment

    String getComment(long snap)
    Get the comment on this breakpoint
    Parameters:
      `snap` - the snap
    Returns:
      the comment, possibly `null`

  - ### remove

    void remove(long snap)
    Remove this breakpoint from the given snap on
    Parameters:
      `snap` - the snap

  - ### delete

    void delete()
    Delete this breakpoint from the trace

  - ### isValid

    boolean isValid(long snap)
    Check if the breakpoint is present at the given snapshot

    In object mode, a breakpoint's life may be disjoint, so checking if the snap occurs between creation and destruction is not quite sufficient. This method encapsulates validity. In object mode, it checks that the breakpoint object has a canonical parent at the given snapshot. In table mode, it checks that the lifespan contains the snap.

    Parameters:
      `snap` - the snapshot key
    Returns:
      true if valid, false if not

  - ### isAlive

    boolean isAlive(Lifespan span)
    Check if the breakpoint is present for any of the given span
    Parameters:
      `span` - the span
    Returns:
      true if its life intersects the span